local coldHeart20stacks = time();
local coldHeart20stacksDamage = 0;
local potionId = 142117--prolonged power
---------Weak Aura Utilities---------
function KamiUI.coldHeartCappedStacks()
    --print(coldHeart20stacks);
    return coldHeart20stacks ~= nil and time()-coldHeart20stacks > 5;
end

function KamiUI.ColdHeartWorthCasting()
    local name,_,_,chCount = UnitBuff("player","Cold Heart") ;
    if (chCount == nil)then
        coldHeart20stacks = nil;
        return false;
    end
    local base, current, posBuff, negBuff = UnitStat("player", 1);
    --local effective = base + posBuff + negBuff;
    --print(base.." "..posBuff.." "..negBuff)
    --KamiUI.KamiLog("Max: "..coldHeart20stacksDamage.." Current: "..(current * 2 * chCount));    
    if (chCount == 20 and coldHeart20stacks == nil)then
        coldHeart20stacks = time();
    end
    if ((current * 2 * chCount) > coldHeart20stacksDamage or KamiUI.coldHeartCappedStacks()) then --times 2 for str-> attack Power conversion
        return true;
    end
    return false;
end
function KamiUI.SetColdHeartMaxDamage()
    baseAp,_,_,_ =  UnitStat("player", 1);
    coldHeart20stacksDamage = baseAp * 2 *20;
end

function KamiUI.AllTalentsLearned()
    local talentGroup = GetActiveSpecGroup()
    KamiUI.SetColdHeartMaxDamage()
    for talentTier = 1, MAX_TALENT_TIERS do
        local learnedThisRow = false;
        local available, selected = GetTalentTierInfo(talentTier, talentGroup, nil, 'player')
        --KamiUI.KamiLog(selected);  
        if (selected ~= 0) then
            learnedThisRow = true;
        end
        if (learnedThisRow == false) then
            return false;
        end
    end
    return true;
end

function KamiUI.MaxStacksDamage()
    return coldHeart20stacksDamage;
end
function KamiUI.ShouldSecondPot()
    --KamiUI.KamiLog("SecondPot");
    local name, potion, gearset = KamiUI.GetBoss();
    local startTime, duration, enable = GetItemCooldown(potionId);
    if (potion == nil and not enable) then
        return false;
    else
        local potionAsNumber = tonumber(potion);
        local percent = (UnitHealth("target")/UnitHealthMax("target"))*100
        if (potionAsNumber == nil) then
            local buffname, rank, icon, count, debuffType, duration, expirationTime, unitCaster, isStealable, 
shouldConsolidate, spellId = UnitBuff("unit", "Exhaustion");
            if (spellId ~= nil) then
                return true;
            end
        elseif (percent <= potionAsNumber) then
            return true;
        end
    end
    return false;
end
function KamiUI.SecondPotionUsed()
    local name, potion, gearset = KamiUI.GetBoss();
    local startTime, duration, enable = GetItemCooldown(potionId);
    if (enable) then
        return false;
    end
    if (potion == nil) then
        local percent = (UnitHealth("target")/UnitHealthMax("target"))*100;
        KamiUI.AddBoss(percent);
        return true;
    end
    return false;
end

KamiUI.SetColdHeartMaxDamage()

